<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Send.php
//      Various sending stuff (Send money to other person, send item to other person)
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.2 (Build 10)
// $Date: 2006-07-29 19:39:33 +1000 (Sat, 29 Jul 2006) $
// $Id: Shop-Send.php 10 2006-07-29 09:39:33Z daniel15 $

if ($_GET['do'] == "sendmoney") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=sendmoney",
		'name' => $txt['shop_send_money'],
	);
	
	//If $_GET['member'] is set, pass it to the page. Otherwise, set it to blank.
	isset($_GET['member']) ? $context['shopSendMoneyMember'] = $_GET['member'] : $context['shopSendMoneyMember'] = "";
	
	$context['sub_template'] = "sendmoney";
	loadTemplate('Shop');
	
} elseif($_GET['do'] == "sendmoney2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=sendmoney",
		'name' => $txt['shop_send_money'],
	);

	$amount = (int) $_POST['amount']; //convert amount to integer

	$result = db_query("SELECT money, memberName, realName
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);

	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$membersUserName = $row['memberName'];
	$membersName = $row['realName'];

	if ($row['money'] < $amount) { //trying to give more than they have
		$context['shop_buy_message'] = $txt['shop_dont_have_much'];
	} elseif ($amount < 0) { //trying to give a negative amount(stealing)
		$context['shop_buy_message'] = $txt['shop_give_negative'];
	} elseif ($amount == 0) { //trying to give 0 (either typed 0, or non-numeric string)
		$context['shop_buy_message'] = $txt['shop_invalid_send_amount'];
	} else {
		//get the id and email of member to send to
		$result = db_query("SELECT ID_MEMBER, memberName, emailAddress
							FROM {$db_prefix}members
							WHERE memberName = '{$_POST['membername']}'
							LIMIT 1", __FILE__, __LINE__);
		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		
		if ($row['memberName'] !== $_POST['membername']) {
			$context['shop_buy_message'] = sprintf($txt['shop_member_no_exist'], $_POST['membername']);
		} else {
			//take money off sender
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money - {$amount}
								WHERE ID_MEMBER = {$ID_MEMBER}
								LIMIT 1", __FILE__, __LINE__);

			//give money to receiver
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money + {$amount}
								WHERE ID_MEMBER = {$row['ID_MEMBER']}
								LIMIT 1", __FILE__, __LINE__);
								
		 
		$pmfrom = array(
			'id' => $ID_MEMBER,
			'name' => $membersName,
			'username' => $membersUserName
		);
		
		$pmto = array(
			'to' => array($row['ID_MEMBER']),
			'bcc' => array()
		);
		
		$subject = sprintf($txt['shop_im_sendmoney_subject'], formatMoney($amount), $membersName);
		$message = sprintf($txt['shop_im_sendmoney_message'], $membersName, formatMoney($amount), $_POST['message']);
		sendpm($pmto, $subject, $message, 0, $pmfrom);

		$context['shop_buy_message'] = sprintf($txt['shop_successfull_send'], formatMoney($amount), $row['memberName']);
		}
	}
	
	$context['sub_template'] = "message";
	loadTemplate('Shop');
	
} elseif($_GET['do'] == "senditems") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=senditems",
		'name' => $txt['shop_send_money'],
	);
	
	$context['shop_send_items'] = "";
	
	$result = db_query("SELECT it.name, inv.id AS ivid, inv.trading
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.ownerid = {$ID_MEMBER} AND inv.itemid = it.id AND inv.trading = 0
						GROUP BY it.id
						ORDER BY it.name ASC ", __FILE__, __LINE__);				
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$context['shop_send_items'] .= "
		<option value ={$row['ivid']}>{$row['name']}</option>";
	}
	$context['sub_template'] = "sendItems";
	loadTemplate('Shop');
	
} elseif($_GET['do'] == "senditems2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=senditems2",
		'name' => $txt['shop_send_money'],
	);
	
	// Current item information
	$result = db_query("SELECT inv.ownerid, inv.itemid, it.name
						FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
						WHERE inv.id = '{$_POST['giftid']}' AND it.id = inv.itemid", __FILE__, __LINE__);
	$rowItem = mysql_fetch_array($result, MYSQL_ASSOC);
	
	if ($rowItem['ownerid'] !== $ID_MEMBER) {
	   die($txt['shop_use_others_item']);
   }
   
	// Get new owner's information
	$result = db_query("SELECT ID_MEMBER
						FROM {$db_prefix}members
						WHERE memberName = '{$_POST['membername']}'", __FILE__, __LINE__);
	$rowNewOwner = mysql_fetch_array($result, MYSQL_ASSOC);
   
   
	// Get current owner's name (current user)
	$result = db_query("SELECT memberName, realName
					FROM {$db_prefix}members
					WHERE ID_MEMBER = {$ID_MEMBER}", __FILE__, __LINE__);
	$rowCurrOwner = mysql_fetch_array($result, MYSQL_ASSOC);
	
	$membersUserName = $rowCurrOwner['memberName'];
	$membersName = $rowCurrOwner['realName'];
	
	
   // Set the new owner
	$result = db_query("UPDATE {$db_prefix}shop_inventory
					SET ownerid = {$rowNewOwner['ID_MEMBER']}
					WHERE id = {$_POST['giftid']}", __FILE__, __LINE__);
	

	$pmfrom = array(
		'id' => $ID_MEMBER,
		'name' => $membersName,
		'username' => $membersUserName
	);

	$pmto = array(
		'to' => array($rowNewOwner['ID_MEMBER']),	
		'bcc' => array()
			);
			
	$subject = $txt['shop_im_senditem_subject'];
	$message = sprintf($txt['shop_im_senditem_message'], $membersName, $rowItem['name'], $_POST['message']);
	sendpm($pmto, $subject, $message, 0, $pmfrom);

	$context['sub_template'] = "message";
	$context['shop_buy_message'] = $txt['shop_transfer_success'];
	loadTemplate('Shop');	
}	
?>